﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class _RadGridDefault : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = PopulateGrid;
    }

    public DataTable PopulateGrid
    {
        get
        {
            DataTable data;

            if (Session["GridData"] == null)
            {
                data = GenerateData();

                Session["GridData"] = data;
            }

            data = (DataTable)Session["GridData"];

            return data;
        }

        set
        {
            Session["GridData"] = value;
        }
    }

    public DataTable GenerateData()
    {
        DataTable data = new DataTable();

        data.Columns.Add("ID", typeof(int));
        data.Columns.Add("Name");
        data.Columns.Add("Description");

        for (int i = 1; i < 31; i++)
        {
            data.Rows.Add(i, "Name" + (i % 5).ToString(), "Description" + i.ToString());
        }

        return data;
    }

    protected void RadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
    {
        Hashtable newValues = (e.CommandArgument as GridBatchEditingEventArgument).NewValues;

        DataTable newData = PopulateGrid;

        DataRow[] row = newData.Select("ID = " + newValues["ID"]);

        row[0]["ID"] = newValues["ID"];
        row[0]["Name"] = newValues["Name"];
        row[0]["Description"] = newValues["Description"];

        newData.AcceptChanges();
    }

    protected void RadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
    {
        Hashtable newValues = (e.CommandArgument as GridBatchEditingEventArgument).NewValues;

        DataTable newData = PopulateGrid;

        DataRow row = newData.NewRow();

        row["ID"] = newValues["ID"];
        row["Name"] = newValues["Name"];
        row["Description"] = newValues["Description"];

        newData.Rows.Add(row);
    }

    protected void RadGrid1_PreRender(object sender, EventArgs e)
    {
        RadGrid grid = sender as RadGrid;

        foreach (GridColumn column in grid.Columns)
        {
            if (column.IsEditable)
            {
                GridColumnEditorBase columnEditor = RadGrid1.MasterTableView.GetBatchColumnEditor(column.UniqueName) as GridColumnEditorBase;

                if (columnEditor is GridTextBoxColumnEditor)
                {
                    (columnEditor as GridTextBoxColumnEditor).TextBoxControl.Attributes.Add("onkeydown", "navigateToCell(this, event, " + (column.OrderIndex - 1) + ");");    
                }
                else if (columnEditor is GridNumericColumnEditor)
                {

                    (columnEditor as GridNumericColumnEditor).NumericTextBox.Attributes.Add("onkeydown", "navigateToCell(this, event, " + (column.OrderIndex - 1) + ");");    
                }
                
            }
        }
    }
}